<!DOCTYPE html>
<html lang="zxx">

 <head>
   <meta charset="utf-8">
   <title>MDEF Daphne Gerodimou</title>
   <meta name="viewport" content="width=device-width, initial-scale=1">
   <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

<!--link rel="stylesheet" href="plugins/bootstrap/bootstrap.min.css"-->
  <!-- Main Stylesheet -->
  <link href="../css/stylevol2.css" rel="stylesheet">

 </head>

 <body>

   <header>
    <div class="container">

       <nav class="nav">
         <lu class="nav lu">
           <li><a class="nav li" href="../index.html">HEY</a></li>
           <li> <a class="nav li" href="../FAB.html">BACK?</a></li>


           <hr>
         </lu>
       </nav>

     </div>
  </header>




<main>



       <div class="containerpost">


            <h2>16</h2>
            <br>
            <br><h3>WILDCARD WEEK</b></h3>
            <br>

            <br> <h3><b>FACULTY :</b></h3>   FABLAB
            <br>
                 <h3><b>LOCATION :</b></h3>  IAAC
            <br>
            <br>
            <br>


                  <br>
                  <br>
                  <br>
              <h3><b>CNC BY THE SEA</b></h3>
              <br>
              <p>

                <br>
                <br>
                <br>
                <br>
                <br>
                <br>
               <img src="../images/fabacademy/diagram.jpg" alt="" class="imagespost">
                 <br>
                 <br>
                 <br>
                This week we took a trip to the sea. A remote trip. Ok it wasn’t really a sea. But still.
The task was to use remotely a custom CNC machine -or else “The Kraken” that the FabLab team assembled and connected to an Arduino Mega. The tool of the machine is a screwdriver and the bed is covered with sand. Therefore, our task was to draw on the sand like we would do in a real beach if life was fair and Covid not there. The Arduino Mega is connected to a Raspberry Pi which gives us the possibility to connect remotely and control the machine from our homes.



                                 <br>
                                 <br>
The raspberry pi as I understood, is connected also to two webcameras that allow us to see what the machine is doing and runs the program that controls the CNC which is called CNC.js. Even though I read the documentation I don’t really understand how it works as I have never worked with a raspberry pi myself.
                                 <br>
                                <br>
                                 <br>

All we needed to do, was to connect to make a drawing, generate the GCODE of that drawing and the connect to the web interface of the machine, upload the gcode and press play. One little thing before that though, was to download from the GitHub repository a .json file and go to settings —> workplace and import it so we can see stream the web-cameras (i think).



  <br>
  <br>

    <br>
    <br>

                                 <h3><b>GCODE</b></h3>
                                 <br>
                                 <p>




                            <br>

GCODE is the language used to directly communicate with the machine. It is basically giving the instructions to a machine controller that informs the movement of the motors as well as their speed and the path that they have to follow.
This machine uses GCODE Marlin open source firmware. In this  <a href="https://marlinfw.org/meta/gcode/">website <a/>  we can find all the information needed concerting the gcode commands and how to use them.
<br>
<br>
<br>
The most important commands for us were:
<br>
<br>
<b>G90</b> - Sets the machine to absolute coordinates
<br>
<b>G21</b> - Sets units as millimetres
<br>
<b>G28</b>- Calibrates the machine to x,y,z Home coordinates. This machine works with open loop system, which means that it is not “smart” enough to understand where it is and return data concerting it’s position. Therefore it is important to reset it to home otherwise it will start drawing from its last position.
<br>
<b>M280P1 S90 </b> - This is important and it should go before the G28 command, in case the cleaning panel attached to the servo is not in this position because it will end up breaking the panel when the machine lowers the z.
<br>
<br>
<br>


I have to say that this was the first time I ever had to generate gcode. There are, as we found out, several different ways to do it.

<br>
The drawing part can be done in any vector program like Adobe Illustrator or Inkscape. If you use a raster image you would have to vectorise it in which ever design software you choose.
<br>
<br>
<b>To generate GCODE you can use :</b>
<br>
.Mods
<br>
.Fabmodules
<br>
.Inkscape (newer versions include a gcodetools extension)
<br>
.Grasshopper / Rhino (with a script that Edu made and provided to us)
<br>
<br>

I am sure there are other ways too but these are the ones that I would be more comfortable using.
<br>
Actually, I suffered a lot with generating the GCODE.
<br>
Here comes a brief discription of my struggles:
<br>
<br>
<b>Ilustrator - Fab modules </b>
<br>
<br>
At first, I tried using illustrator and then Fabmodules as I have used both before. The problem was that fabmodules for some reason would not open my svg file. I used online converter to convert .ai file to svg and somehow then Fabmodules was able to open the file ( I really don’t know why) but then it changed the size of template I had defined so I decided to to try another way.
<br>
<br>
<b>Inkscape</b>
<br>
<br>
So next, I tried using Inkscape. I made a drawing and then used the Gcodetools in the extensions window to generate the gcode. In the beginning all the gcode files I generated were empty and I couldn’t figure out why and then I realised that I was doing something extremely stupid. I HAD NOT SELECTED MY DRAWING. Yes, people. Select the drawing first, don’t be stupid like me.
<br>
<br>
<br>
<img src="../images/fabacademy/inkscapegtool.jpg" alt="" class="imagespost">
 <br>
 <br>
 <br>

Nonetheless, I still had some problems because Inkscape gave me a warning, before saving the gcode, of having extra unnecessary data in my code which was true as you can see below.
<br>
<br>
<img src="../images/fabacademy/inkscapeproblem.jpg" alt="" class="gif">
 <br>
 <br>
 <br>
 <br>
 <br>
 <img src="../images/fabacademy/moredata.jpg" alt="" class="imagespost">
  <br>
  <br>
  <br>
 I researched online for this problem and found that it is possibly a problem with the extension or the version of Inkscape that I am using but I am not sure to be honest as I decided to abandon Inkscape at this point.
Nonetheless, here is a <a href="https://www.ctoom.com/tutorial/how-to-create-g-code-file-with-inkscape/" >tutorial <a/> on how to generate gcode using Inkscape.
  <br>
  <br>
  <b>Grasshoper </b>
  <br>
  <br>
  So as it turns out, the grasshopper script was the best and more effortless way to generate the gcode (thanks Edu). All you need to do is open Rhino—> Grasshopper—> open the file (ignore grasshopper warnings complaining, it probably has to do with the difference between the version of grasshopper you have versus the version that the script was created, but it doesn’t influence the code).
  <br>
  <br>
Then you can see in the Rhino interface a simulation of the CNC bed. This is very useful because you can better understand the size of your drawing in comparison to the bed of the cnc and adjust accordingly the position as well as the scale. I used a curve polyline to create my drawing. One thing you need to pay attention to is to make sure that the drawing is on the same level as the bed (z = 0)
<br>
<br>
<img src="../images/fabacademy/Rhinokraken.jpg" alt="" class="imagespost">
 <br>
 <br>
 <br>

Then, once you draw your file, you select your geometry, you go to the grasshopper file and right click on the geo component —> set multiple geometries. This is the way you always connect a geometry from rhino to the geometry components in Grasshopper.

<br>
<br>
<br>
<img src="../images/fabacademy/krakenscript.jpg" alt="" class="imagespost">
 <br>
 <br>
 <br>
Then you can adjust the settings according to the machine’s constraints. In this case we knew that the speed should be the maximum 5000 for the air moving speed and for the drawing speed 3000. The drawing height is something that you can experiment with but it was mostly between 8-15. I used 8 and it worked fine. The air moving height should be minimum 40 to be safe.
The last thing is to go to the panel where the gcode data are generated —> right click —> Copy data only! (important so you don’t also copy the list numbers of the panel)

<br>
<br>
After copying the data form Grasshopper you have to open a text editor, I used ATOM and copy the code. There you need to check if something is wrong in your code or if something is missing. In my case my code only had the travel gcode therefore I added G28 in the beginning so that the machine can go to home before starting my drawing.
<br>
<br>
<br>
<img src="../images/fabacademy/atomgcode.jpg" alt="" class="imagespost">
 <br>
 <br>
 <br>
 <img src="../images/fabacademy/heyboy.jpg" alt="" class="imagespost">
  <br>
  <br>
  <br>

 <img src="../images/fabacademy/cncmakingit.jpg" alt="" class="">
  <br>
  <br>
  <br>
<br>
<br>
<h3><b>CLEANING</b></h3>
<br>
<p>
  I personally didn’t need to clean the machine as I did it during the session and it the bed was cleaned before my drawing but I observed how to clean it. Basically, the machine has a panel/plate that is attached to a servomotor. For this we had to upload another gcode that was specifically for moving the servo’s degrees so the plate can be vertical in a way that it would push the sand and erase the drawing. Because the servomotor attachment to the tool is obviously not very endurable to our mistreating in the end it ended up being slightly titled which meant that the values of this gcode should be adapted while also seeing the web camera to make sure that the plate is actually horizontal or vertical. This means that setting the degrees to 0 or 90 didn’t mean that it was indeed the in this position.

Poor little servomotor, we collectively apologise.









<br>
<br>

<h3><b>FILES</b></h3>
<br>
<br>
                           <p>
                             <a href="../files/KrakenControl.gh">Grasshoper file <a/>
                                  <br>
                                  <a href="../files/CNCbythesea.gcode">Gcode<a/>
                                            <br>

                             <a href="../files/cleaningcode.gcode">Cleaningcode<a/>
                                       <br>




                       </p>
                       <br>















</main>

</body>











<!-- Navigation Start -->
<!-- Header Start -->





















<!-- Footer End -->

<!-- jQuery -->
<script src="plugins/jQuery/jquery.min.js"></script>
<!-- Bootstrap JS -->
<script src="plugins/bootstrap/bootstrap.min.js"></script>
<script src="plugins/aos/aos.js"></script>
<script src="plugins/owl-carousel/owl.carousel.min.js"></script>
<script src="plugins/shuffle/shuffle.min.js"></script>
<script src="plugins/magnific-popup/jquery.magnific-popup.min.js"></script>
<script src="plugins/animated-text/animated-text.js"></script>
<script src="plugins/counto/apear.js"></script>
<script src="plugins/counto/counTo.js"></script>

 <!-- Google Map -->
<script src="plugins/google-map/map.js"></script>
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAkeLMlsiwzp6b3Gnaxd86lvakimwGA6UA&callback=initMap"></script>
<!-- Main Script -->
<script src="js/script.js"></script>

</html>
